#!/usr/bin/perl
#
# $Id: apache-larrd.pl,v 1.10 2003/03/18 18:50:49 cncook Exp $
#
# apache-larrd.pl: larrd module to collect apache server stats
#
# Scott Walters Copyright 1999, 2000
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

#For testing only
#use lib "/usr/local/larrd";
#require "larrd-config.pl";
#use lib $ENV{'RRDPM'};
#use lib "/usr/local/rrdtool/lib/perl";

# this is for after install
use RRDs;
use IO::Socket;

$DEBUG = 1 if $ENV{'DEBUG'}; 
$ERROR = 1 if $ENV{'ERROR'};

if ($DEBUG) {
  use Data::Dumper ;
  $ERROR = 1;
} 

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

%host_h = (
#    'your-domain.dom' => {
#        port => "80",
#        url  => "/server-status?auto",
#    },
#    'your-otherdomain.dom' => {
#        port => "80",
#        url  => "/server-status?auto",
#    },
);

# Apache's DS's

$ds = "apache";

@ds = ("DS:TA:DERIVE:600:0:U",
       "DS:TKB:DERIVE:600:0:U",
       "DS:BW:GAUGE:600:1:U",
       "DS:IW:GAUGE:600:1:U",
       "DS:CPU:GAUGE:600:0:U",
       "DS:REQPERSEC:GAUGE:600:0:U"
      ); 

       #"DS:BS:GAUGE:600:1:U",     # Busy Servers
       #"DS:IS:GAUGE:600:1:U",    # Idl Servers
# go to the data area for simplication of the list
if($ENV{'LARRDCOMM'} =~ /DATA/i) {
	chdir "$ENV{'BBVAR'}/data" || die "$0: $!";
} else {
	chdir "$ENV{'BBLOGS'}" || die "$0: $!";
}

foreach $host ( keys %host_h ) {

	$ta = "U";
 $tkb  = "U";
#$bs = "U";
#$is = "U";
$bw = "U";
$iw = "U";
$cpu = "U";
$req_per_sec = "U";

	print "$0 : DEBUG host=$host, url=$host_h{$host}{url}, port=$host_h{$host}{port}\n\n" if $DEBUG;

	unless( $socket = new IO::Socket::INET (
		PeerAddr => $host,
		PeerPort => $host_h{$host}{'port'},
		Proto    => "tcp",
		Type     => SOCK_STREAM) ){

	print qq/$0: ERROR failed to open socket : PeerAddr => $host, PeerPort => $host_h{$host}{'port'}, Proto => "tcp", Type => SOCK_STREAM : $!\n/ if $ERROR;
		next;
	}
	print $socket "GET $host_h{$host}{'url'}\n\n";

	print "$0 : DEBUG GET $host_h{$host}{'url'} $host_h{$host}{'port'}\n\n" if $DEBUG;

	while ( defined ($status = <$socket>) ) {
		chomp ($status);
		print "$0 : DEBUG $status\n" if $DEBUG;

		if($status =~ /Total Accesses/) {
			($stuff,$ta) = split ": ",$status;
			next;
		} elsif ($status =~ /Total kBytes/) {
			($stuff,$tkb) = split ": ",$status;
			next;
		#} elsif ($status =~ /BusyServers/) {
			#($stuff,$bs) = split ": ",$status;
			#next;
		#} elsif ($status =~ /IdleServers/) {
			#($stuff,$is) = split ": ",$status;
			#next;
                } elsif ($status =~ /BusyWorkers/) {
                        ($stuff,$bw) = split ": ",$status;
                        next;
                } elsif ($status =~ /IdleWorkers/) {
                        ($stuff,$iw) = split ": ",$status;
                        next;
                } elsif ($status =~ /CPULoad/) {
                        ($stuff,$cpu) = split ": ",$status;
                        if ($cpu =~ /^\./) {
                            $cpu = 0 . $cpu;
                        }
                        next;
                } elsif ($status =~ /ReqPerSec/) {
                        ($stuff,$req_per_sec) = split ": ",$status;
                        if ($req_per_sec =~ /^\./) {
                            $req_per_sec = 0 . $req_per_sec;
                        }
                        next;
		}

	}
	print "$0 : DEBUG TA=$ta, TKB=$tkb, BS=$bs, IS=$is BW=$bw IW=$iw CPU=$cpu REQPERSEC=$req_per_sec\n" if $DEBUG; 

	$RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

	print "$0 : RRD=$RRD\n" if $DEBUG;

	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {
		
		# but thought 'standardizing' RRD's would be worth it
		# 30 seconds....
		@rras = split " ",$ENV{'RRAS'};
print "RRD: $RRD, ds: @ds, rras: @rras" if DEBUG;
		RRDs::create($RRD,@ds,@rras);
		$ERR=RRDs::error;
		if($ERR) {
			print "$0: ERROR creating $RRD: $ERR\n" if $ERROR;
			next; #does this work? yup!
		}
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

        # Check counter last values to make sure counter isn't less that
        # previous.  It that is the case insert a U into rrdtool.
        # We use the info last_ds.

	my ($info) = RRDs::info($RRD);
        $ERR=RRDs::error;
	if($ERR) {
                print "$0: ERROR could not fetch last update for $RRD: $ERR\n" if $ERROR;
        }

#	if($ta < $info->{'ds[TA].last_ds'}  ) { $ta = "U"; }
#	if($tkb < $info->{'ds[TKB].last_ds'} ) { $tkb = "U"; }

        warn Data::Dumper->Dump([$info],["info"]) if $DEBUG;

	print "$0 : DEBUG lastupate ($info->{'last_update'})
                    ta_last($info->{'ds[TA].last_ds'}) ta ($ta)
                    tkb_last($info->{'ds[TKB].last_ds'}) tkb ($tkb)
                    bw($info->{'ds[BW].last_ds'}) bw ($bw)
                    iw($info->{'ds[IW].last_ds'}) iw ($iw)
                    cpu_last($info->{'ds[CPU].last_ds'}) cpu ($cpu)
                    req_per_sec($info->{'ds[REQPERSEC].last_ds'}) req_per_sec ($req_per_sec)
                \n" if $DEBUG;

	# now update the RRD
	RRDs::update("$RRD",
                     "--template",
                     "TA:TKB:BW:IW:CPU:REQPERSEC",
                     "N:$ta:$tkb:$bw:$iw:$cpu:$req_per_sec"
                    );
        $ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }

}	
##############################################
# end of script
##############################################
