#!/usr/bin/perl
#
# $Id: bbnet-larrd.pl,v 1.18 2003/04/02 16:44:09 cncook Exp $
#
# bbnet-larrd.pl - larrd module for collecting tcp
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# 31 Jan 2003   Craig Cook
# Made fping graph work if you set the column header to "conn"

# 13 Mar 2003   Craig Cook
# created @tcp_array
# created @ds
# changed $tcp to $ds
# added patch from James Overbeck for fping
# added comment for James' patch
#
# 21 Mar 2003   Craig Cook
# Fixed bug where I had removed some lines by mistake

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

@tcp_array = ("ssh","telnet","nntp","ftp","pop","pop-2","pop2","pop-3","pop3","smtp","imap2","conn","fping","imap");

@ds = ("DS:sec:GAUGE:600:0:U",
       );

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBLOGS'}";

# go to the logs area and see what data we can gather 

# http will be tougher cause log can check multiple sites
foreach $ds (@tcp_array) { 

  LOG: while (  defined ($log = <*.$ds>)  ) {
 
	# you need three things to collect data
	# RRD - an RRD
	# ctime  - a timestamp (in epoch)
	# sec - value of data (could be multiple values, see disk-larrd.sh for example)	


        $host=$log;
        # create some handy vars
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

	$RRD="$ENV{'BBRRDS'}/$host.tcp.$ds.rrd";	

	# now lets get the data 
	# look through the file and get what you want

	# hacked in the conn since it varies from bbnet, but trends tcp connects
	local($sec);

	($ctime) = (stat($log))[10];

        open(LOG,"$log");

        $status = <LOG>;

        if($status !~ /green|yellow|red/) {
                print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
                next LOG;
        }

	# fping
        if (
              ($ds eq 'fping') ||
              (($ds eq 'conn') && ($status =~ /\balive\b/))
            ) { # need to go back to start of log, since fping.sh puts
                # its results on the same line at the status message
               seek(LOG,0,0);
        }

	while (defined ($line = <LOG>)) {

                next if $line =~ /^$/;

		if ( ($line =~ /Seconds/) && ($ds ne "conn") ) {
			($dummy,$sec) = split " ",$line,3;
			last;

		} elsif ( ($line =~ /time=/) && ($ds eq "conn") ) {

                        # is this the best method for finding ping conn

			($dummy,$sec) = split "time=",$line;
			($sec,$dummy) = split " ",$sec;
			$sec=$sec/1000; # convert milliseconds to seconds

			if($dummy =~ /^usec/) {
				$sec=$sec/1000;
			} elsif ($dummy =~ /^sec/) {
				$sec=$sec*1000;
			}

		} elsif (  # are we using fping?
                         ($line =~ /alive\s+\((\d+\.\d+)\s+ms\)/) &&
                         ( ($ds eq "conn") or ($ds eq "fping") )
                        ) {
            		  $sec = $1 / 1000;
                }     
	}

	print "$0: DEBUG sec: $sec\n" if $ENV{'DEBUG'};

	if ($sec ne "") {
	
		# If it is looking at the log with no larrdable data
		# it won't create the rrd and in turn the graph
		# it makes sense this way.

	        # if it doesn't exist, make it
	        if ( not -f $RRD ) {
	                        # RRAS defined in larrd.pl
	                        @rras = split " ",$ENV{'RRAS'};
	                        RRDs::create($RRD,@ds,@rras);
	                        $ERR=RRDs::error;
	                        if($ERR) {
	                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'}) ;
					next;
	                        }
	                $ctime="N";
	                print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	        }

		print "$RRDTOOL : DEBUG update $RRD $ctime:$sec\n" if ($ERR{'DEBUG'});
		RRDs::update($RRD,"$ctime:$sec");
	        $ERR=RRDs::error;

	        if ($ERR) {
	               print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
	        }
	}
  }
}

# Now we will do http since it have have several urls we break up the
# rrds into seperate files for a 1 to 1 relationship.  This allows
# easy additions of urls.

# it is just nicer this way.

$ds="http";

LOG: while (  defined ($log = <*.$ds*>)  ) {

        # you need three things to collect data
        # RRD - an RRD
        # ctime  - a timestamp (in epoch)
        # sec - value of data (could be multiple values, see disk-larrd.sh for example)

        $host=$log;
        # create some handy vars
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

	local($sec);

	($ctime) = (stat($log))[10];

	# Read the http urls in to a hash
	open(LOG,"$log");

	$status=<LOG>;

        if($status !~ /green|yellow|red/) {
                print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
                next LOG;
        }

	while (defined ($line=<LOG>)){
		if($line =~ /^&/) {
			($dummy,$url) = split " ",$line,3;
			$url =~ s/http\:\/\///g;
			$url =~ s/\//\,/g;
		}
		if($line =~ /Seconds/) {
                        ($dummy,$sec) = split " ",$line,3;
			$http{$url}=$sec;
		}
	}
	
	# with the hash in place we will roll our own rrds
	foreach $url (keys %http) {

        $RRD="$ENV{'BBRRDS'}/$host.tcp.$ds.$url.rrd";

        if ($sec ne "") {
	        # if it doesn't exist, make it
	        if ( not -f $RRD ) {
	                        # RRAS defined in larrd.pl
	                        @rras = split " ",$ENV{'RRAS'};
	                        RRDs::create($RRD,@ds,@rras);
	                        $ERR=RRDs::error;
	                        if($ERR) {
	                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
					next;
	                        }
	                $ctime="N";
	                print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	        }

                RRDs::update($RRD,"$ctime:$http{$url}");
	        $ERR=RRDs::error;
	        if($ERR) {
	               print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
	        }
        }
	}
	# Very important
	undef %http;
}



##############################################
# end of script
##############################################
