#!/usr/bin/perl
#
# $Id: iostat-larrd.pl,v 1.6 2003/03/18 16:48:12 cncook Exp $
#
# iotstat-larrd.pl: larrd module to collect I/O stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# this is for after install
use lib $ENV{'RRDPM'};
use RRDs;

##################################
# SETUP
##################################

# 1. Define the extention for the metric

$ds = "iostat";

@ds = ("DS:rs:GAUGE:600:1:U",
       "DS:ws:GAUGE:600:1:U",
       "DS:krs:GAUGE:600:1:U",
       "DS:kws:GAUGE:600:1:U",
       "DS:wait:GAUGE:600:1:U",
       "DS:actv:GAUGE:600:1:U",
       "DS:wsvc_t:GAUGE:600:1:U",
       "DS:asvc_t:GAUGE:600:1:U",
       "DS:w:GAUGE:600:1:U",
       "DS:b:GAUGE:600:1:U",
       "DS:sw:GAUGE:600:1:U",
       "DS:hw:GAUGE:600:1:U",
       "DS:trn:GAUGE:600:1:U",
       "DS:tot:GAUGE:600:1:U",);

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

# NOTE : See README about $ENV{'LARRDCOMM'}

# Glob the bind logs and data
my %h_fn;

# Perl Cookbook Recipe 9.5
opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBLOGS'}/$log";
}
closedir(DIR);

opendir(DIR, "$ENV{'BBVAR'}/data") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBVAR'}/data/$log";
}
closedir(DIR);

while ( ($host,$log) = each %h_fn ) {


        print "$0 : DEBUG log=$log\n" if ($ENV{'DEBUG'});

        open(LOG,"$log");
	
        $temp = <LOG> if $log =~ /$ENV{'BBLOGS'}/io;

#	Soon?
#	$bbhosttype = <LOG>;
#	chomp $bbhosttype;
#	print "$0: DEBUG bbhosttype = $bbhosttype\n" if ($ENV{'DEBUG'});

# 2. Grab the data from the log how ever you need

	while( defined($iostat = <LOG>) ) {
		next if $iostat =~ /BEGINKEY/;
		last if $iostat =~ /ENDKEY/;
		chomp $iostat;
		($device,$part) = split " ",$iostat;
		$d_h{$device}=$part;
	}
        while( defined($iostat = <LOG>) ) {
		next if $iostat =~ /BEGINDATA/;
		last if $iostat =~ /ENDDATA/;
                next if $iostat =~ /device/;
		chomp $iostat;
		($rs,$ws,$krs,$kws,$wait,$actv,$wsvc_t,$asvc_t,
		$w,$b,$sw,$hw,$trn,$tot,$device) = split " ",$iostat;

# 3. grab the timpstamp for rrd. 

	        ($ctime) = (stat($log))[10];
		print "$0: DEBUG ctime = $ctime\n" if ($ENV{'DEBUG'});


# 4. create the rrd filename

		($diskname = $d_h{$device}) =~ s/\//\,/g;

                if ( $diskname eq "\," ) {
                        $diskname="\,root"
                }


	        $RRD="$ENV{'BBRRDS'}/$host.$ds.$diskname.rrd";

	        print "$0 : RRD=$RRD\n" if ($ENV{'DEBUG'});

		# see if the RRD is around, if not make it	
		if ( not -f $RRD ) {
		
			# keeping this much disk data seems overkill
			# but thought 'standardizing' RRD's would be worth it
			# 30 seconds....
			$ctime--;
			@rras = split " ",$ENV{'RRAS'};
			RRDs::create($RRD,"-b $ctime",@ds,@rras);
			$ERR=RRDs::error;
			if($ERR) {
				print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next; #does this work? yup!
			}
			$ctime++;
			print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
		}

# 5. Put your data from step 2 to the rrd

		print "$0 : rs=$rs, ws=$ws, krs=$krs, kws=$kws, wait=$wait, actv=$actv, wsvc_t=$wsvc_t, asvc_t=$asvc_t, w=$w, b=$b, sw=$sw, hw=$hw, trn=$trn, tot=$tot\n" if ($ENV{'DEBUG'});

		# now update the RRD
		RRDs::update("$RRD","$ctime:$rs:$ws:$krs:$kws:$wait:$actv:$wsvc_t:$asvc_t:$w:$b:$sw:$hw:$trn:$tot");
		$ERR=RRDs::error;
		if($ERR) {
			print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
		}
        }
        close(LOG);
        unlink $log if $log =~ /$ENV{'BBVAR'}\/data/io;

}	
##############################################
# end of script
##############################################

