#!/usr/bin/perl
#
# $Id: mailq-larrd.pl,v 1.2 2003/03/18 16:48:12 cncook Exp $
#
# la-larrd.pl - larrd module for collecting Load Average stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#
# Christian Pearce
# pearcec@PacketPushers.com
#  
#
# Craig Cook 13 Mar 2003
# Removed incorrect DEBUG line
# Created @ds
# Created $ds
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

$ds = "mailq";

@ds = ("DS:mailq:GAUGE:600:0:U",
      );

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBLOGS'}";

# Glob the logs
LOG: while (  defined ($log = <*.$ds>)  ) {

        $host=$log;
        # create some handy vars
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        ($ctime) = (stat($log))[10];

	# Grab Load Avg line
        open(LOG,"$log");
	$line=<LOG>;
	close(LOG);

	if($line !~ /green|yellow|red/) {
		print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
		next LOG;
	}

	chomp $line;

	# New attempt and grabing procs and users.
	$line =~ /(\d+)\s+requests/o; 
	$mailq = $1;	

	
	# RRD for mailq
	
	$RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

	# if it doesn't exist, make it 
	if ( not -f $RRD ) {
			# RRAS defined in larrd.pl
			@rras = split " ",$ENV{'RRAS'};
			RRDs::create($RRD,@ds,@rras);
                        $ERR=RRDs::error;
                        if($ERR) {
                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next;
                        }
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

	RRDs::update("$RRD","$ctime:$mailq");
        $ERR=RRDs::error;
        if($ERR) {
 	       print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }

	# Sloppy
        ($ctime) = (stat($log))[10];

}
##############################################
# end of script
##############################################

