#!/usr/bin/perl
#
# $Id: netstat-larrd.pl,v 1.8 2003/03/18 16:48:12 cncook Exp $
#
# netstat-larrd.pl: larrd module to collect network stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks
#
# Craig Cook  13 Aug 2002
#  Applied hpux patch from kstailey

# this is for after install
use lib $ENV{'RRDPM'};
use RRDs;

##################################
# SETUP
##################################

# 1. Define the extention for the metric

$ds = "netstat";

@ds = (); # not defined here, dynamically built later

# We are going to follow 
%htonet = (solaris => {
		udpInDatagrams    => ['DERIVE','udpInDatagrams'],
		udpOutDatagrams   => ['DERIVE','udpOutDatagrams'],
		udpInErrors       => ['DERIVE','udpInErrors'],
		tcpActiveOpens    => ['DERIVE','tcpActiveOpens'],
		tcpPassiveOpens   => ['DERIVE','tcpPassiveOpens'],
		tcpAttemptFails   => ['DERIVE','tcpAttemptFails'],
		tcpEstabResets    => ['DERIVE','tcpEstabResets'],
		tcpCurrEstab      => ['GAUGE'  ,'tcpCurrEstab'],
		tcpOutDataBytes   => ['DERIVE','tcpOutDataBytes'],
		tcpInInorderBytes => ['DERIVE','tcpInInorderBytes'],
		tcpInUnorderBytes => ['DERIVE','tcpInUnorderBytes'],
		tcpRetransBytes   => ['DERIVE','tcpRetransBytes']
		},
	    redhat => {
		"packets received"            => ['DERIVE','udpInDatagrams'],
		"packets sent"                => ['DERIVE','udpOutDatagrams'],
		"packet receive errors"       => ['DERIVE','udpInErrors'],
		"active connections openings" => ['DERIVE','tcpActiveOpens'],
		"passive connection openings" => ['DERIVE','tcpPassiveOpens'],
		"failed connection attempts"  => ['DERIVE','tcpAttemptFails'],
		"connection resets received"  => ['DERIVE','tcpEstabResets'],
		"connections established"     => ['GAUGE'  ,'tcpCurrEstab'], 
		"segments received"           => ['DERIVE',
						  'tcpInInorderBytes'],
		"segments send out"           => ['DERIVE','tcpOutDataBytes'],
		"segments retransmited"       => ['DERIVE','tcpRetransBytes']
 		},
            hpux => {
                udpInDatagrams    => ['DERIVE','udpInDatagrams'],
                udpOutDatagrams   => ['DERIVE','udpOutDatagrams'],
                udpInErrors       => ['DERIVE','udpInErrors'],
                tcpActiveOpens    => ['DERIVE','tcpActiveOpens'],
                tcpPassiveOpens   => ['DERIVE','tcpPassiveOpens'],
                tcpAttemptFails   => ['DERIVE','tcpAttemptFails'],
                tcpEstabResets    => ['DERIVE','tcpEstabResets'],
                tcpCurrEstab      => ['GAUGE'  ,'tcpCurrEstab'],
                tcpOutDataBytes   => ['DERIVE','tcpOutDataBytes'],
                tcpInInorderBytes => ['DERIVE','tcpInInorderBytes'],
                tcpInUnorderBytes => ['DERIVE','tcpInUnorderBytes'],
                tcpRetransBytes   => ['DERIVE','tcpRetransBytes']
                },
           aix => {
                udpInDatagrams    => ['DERIVE','udpInDatagrams'],
                udpOutDatagrams   => ['DERIVE','udpOutDatagrams'],
                udpInErrors       => ['DERIVE','udpInErrors'],
                tcpActiveOpens    => ['DERIVE','tcpActiveOpens'],
                tcpPassiveOpens   => ['DERIVE','tcpPassiveOpens'],
                tcpAttemptFails   => ['DERIVE','tcpAttemptFails'],
                tcpEstabResets    => ['DERIVE','tcpEstabResets'],
                tcpCurrEstab      => ['GAUGE'  ,'tcpCurrEstab'],
                tcpOutDataBytes   => ['DERIVE','tcpOutDataBytes'],
                tcpInInorderBytes => ['DERIVE','tcpInInorderBytes'],
                tcpInUnorderBytes => ['DERIVE','tcpInUnorderBytes'],
                tcpRetransBytes   => ['DERIVE','tcpRetransBytes']
                },
            sco => {
                udpInDatagrams    => ['DERIVE','udpInDatagrams'],
                udpOutDatagrams   => ['DERIVE','udpOutDatagrams'],
                udpInErrors       => ['DERIVE','udpInErrors'],
                tcpActiveOpens    => ['DERIVE','tcpActiveOpens'],
                tcpPassiveOpens   => ['DERIVE','tcpPassiveOpens'],
                tcpAttemptFails   => ['DERIVE','tcpAttemptFails'],
                tcpEstabResets    => ['DERIVE','tcpEstabResets'],
                tcpCurrEstab      => ['GAUGE'  ,'tcpCurrEstab'],
                tcpOutDataBytes   => ['DERIVE','tcpOutDataBytes'],
                tcpInInorderBytes => ['DERIVE','tcpInInorderBytes'],
                tcpInUnorderBytes => ['DERIVE','tcpInUnorderBytes'],
                tcpRetransBytes   => ['DERIVE','tcpRetransBytes']
                },
	);
		

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# NOTE : See README about $ENV{'LARRDCOMM'}

# Glob the bind logs and data
my %h_fn;

# Perl Cookbook Recipe 9.5
opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBLOGS'}/$log";
}
closedir(DIR);

opendir(DIR, "$ENV{'BBVAR'}/data") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.$ds$/io;
        my $host = $log;
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        $h_fn{$host}="$ENV{'BBVAR'}/data/$log";
}
closedir(DIR);

while ( ($host,$log) = each %h_fn ) {

        print "$0 : DEBUG log=$log\n" if ($ENV{'DEBUG'});

# 2. grab the timpstamp for rrd. 

        ($ctime) = (stat($log))[10];

	print "$0 : DEBUG ctime = $ctime\n" if ($ENV{'DEBUG'});

	open(LOG,"$log");
        $temp = <LOG> if $log =~ /$ENV{'BBLOGS'}/io;
	$bbhosttype = <LOG>;
	chomp $bbhosttype;

	print "$0 : DEBUG bbhosttype = $bbhosttype\n" if ($ENV{'DEBUG'});



# 3. Grab the data from the log how ever you need

# Checking for existence prevents perl from autovivifying the %htonet hash

	local(%hash)=();
	if($bbhosttype eq "solaris") {
		while (defined($netstat = <LOG>) ) {
			$netstat =~ /\w*\s+(\w+)\s*\=\s*(-)?(\d+)\s*((\w+)\s*\=\s*(-)?(\d+))?/o;
			if(defined $1) {
				print "$0 : DEBUG 1=$1 2=$2 3=$3\n" if ($ENV{'DEBUG'});
				$hash{$1} = "$2$3" if exists $htonet{$bbhosttype}{$1};
			}
			if(defined $4) {
				print "$0 : DEBUG 5=$5 6=$6 7=$7\n" if ($ENV{'DEBUG'});
				$hash{$5} = "$6$7" if exists $htonet{$bbhosttype}{$5};
			}
		}
	} elsif ($bbhosttype eq "redhat") {
		while (defined($netstat = <LOG>) ) {
			$netstat =~ /\s*(-)?(\d+)\s*((\w+\s+)*\w+)/o;
			if(defined $2) {
				print "$0 : DEBUG 1=$1 2=$2 3=$3\n" if ($ENV{'DEBUG'});
				$hash{$htonet{$bbhosttype}{$3}[1]} = "$1$2" if exists $htonet{$bbhosttype}{$3};
			}
		} 
        } elsif ($bbhosttype eq "hpux") {
                while (defined($netstat = <LOG>) ) {
                   $netstat =~ /(\w+)\s+\=\s+(-)?(\d+)/o;
                   if(defined $1) {
                       print "$0 : DEBUG 1=$1 2=$2 3=$3\n" if ($ENV{'DEBUG'});
                       $hash{$1} = "$2$3" if exists $htonet{$bbhosttype}{$1};
                   }
                }
	} elsif ($bbhosttype eq "aix") {
                while (defined($netstat = <LOG>) ) {
                   $netstat =~ /(\w+)\s+\=\s+(-)?(\d+)/o;
                   if(defined $1) {
                       print "$0 : DEBUG 1=$1 2=$2 3=$3\n" if ($ENV{'DEBUG'});
                       $hash{$1} = "$2$3" if exists $htonet{$bbhosttype}{$1};
                   }
                }
	} elsif ($bbhosttype eq "sco") {
                while (defined($netstat = <LOG>) ) {
                   $netstat =~ /(\w+)\s+\=\s+(-)?(\d+)/o;
                   if(defined $1) {
                       print "$0 : DEBUG 1=$1 2=$2 3=$3\n" if ($ENV{'DEBUG'});
                       $hash{$1} = "$2$3" if exists $htonet{$bbhosttype}{$1};
                   }
                }
	} else {
		print "$0 : WARN bbostype undetermined : $bbhosttype ignoring.\n" if ($ENV{'DEBUG'});
                next; #skip to next host
	}
			
# 4. create the rrd filename

        $RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

        print "$0 : RRD=$RRD\n" if ($ENV{'DEBUG'});

	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {

		# build the @ds
		local(@ds)=();
		foreach (values %{$htonet{$bbhosttype}}) {
			if ($_->[0] eq "GAUGE") {
				$start="1";
			} else {
				$start="0";
			}
			push @ds,"DS:$_->[1]:$_->[0]:600:$start:U";
		}	

		# keeping this much disk data seems overkill
		# but thought 'standardizing' RRD's would be worth it
		# 30 seconds....
		$ctime--;
		@rras = split " ",$ENV{'RRAS'};
		RRDs::create($RRD,"-b $ctime",@ds,@rras);
		$ERR=RRDs::error;
		if($ERR) {
			print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
			next; #does this work? yup!
		}
		$ctime++;
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

# 5. Put your data from step 2 to the rrd

	# now update the RRD
	
	local($rrdupdate)="$ctime";
	foreach (values %{$htonet{$bbhosttype}}) {
		print "$0 : $_->[1]=$hash{$_->[1]}\n" if ($ENV{'DEBUG'});
		$rrdupdate = "$rrdupdate:$hash{$_->[1]}";
	}

	print "$0 : DEBUG rrdupate=$rrdupdate\n" if ($ENV{'DEBUG'});

	RRDs::update("$RRD","$rrdupdate");
        $ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }
        unlink $log if $log =~ /$ENV{'BBVAR'}\/data/io;

}	
##############################################
# end of script
##############################################
