#!/usr/bin/perl
#
# $Id: dns-larrd.pl,v 1.3 2003/03/18 16:48:12 cncook Exp $
#
# dns-larrd.pl - larrd module for collecting Load Average stats 
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#
# Christian Pearce
# pearcec@PacketPushers.com
#  
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

##################################
# Start of script
##################################

if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
}

if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
}

if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
}

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBHOME'}/www/logs";

# Glob the dns dig logs (just because it is easier)
LOG: while (  defined ($log = <*.dnsdig>)  ) {

        $host=$log;
        # create some handy vars
        $host =~ s/\.dnsdig//;
        $host =~ s/\,/\./g;

        ($ctime) = (stat($log))[10];

	# Grab Load Avg line
        open(LOG,"$log");
	@lines=<LOG>;
	close(LOG);

#	if($lines[0] !~ /green|yellow|red/) {
#		print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
#		next LOG;
#	}

	foreach(@lines) {
		if($_=~ /Total query/i) {
			# split the log in to fields

			@dnsdig = split " ",$_;
		}
	}

	print "$0: DEBUG dnsdig = $dnsdig[4]\n" if $ENV{'DEBUG'};
	
	# getting RRD
	
	$RRD="$ENV{'BBRRDS'}/$host.dnsdig.rrd";

	# if it doesn't exist, make it 
	if ( not -f $RRD ) {
			# RRAS defined in larrd.pl
			@rras = split " ",$ENV{'RRAS'};
			RRDs::create($RRD,"DS:dnsdig:GAUGE:600:0:U",@rras);
                        $ERR=RRDs::error;
                        if($ERR) {
                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next;
                        }
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

	print "$0: DEBUG $RRD $ctime:$dnsdig[4]\n" if $ENV{'DEBUG'};

	RRDs::update("$RRD","$ctime:$dnsdig[4]");
        $ERR=RRDs::error;
        if($ERR) {
 	       print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }
  

}

# Glob the dns stats logs
LOG: while (  defined ($log = <*.dnsstats>)  ) {

        $host=$log;
        # create some handy vars
        $host =~ s/\.dnsstats//;
        $host =~ s/\,/\./g;

        ($ctime) = (stat($log))[10];

	# Grab Load Avg line
        open(LOG,"$log");
	@lines=<LOG>;
	close(LOG);

	if($lines[0] !~ /green|yellow|red/) {
		print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
		next LOG;
	}

	# Build stats from log

        local($total);

	foreach(@lines) {
		@dnsstats = split " ",$_,5;
		if($dnsstats[3] eq "reset") {
			$reset=$dnsstats[0];
		}
		if($dnsstats[1] eq "A") {
			$A=$dnsstats[0]/$reset;
		}
		if($dnsstats[1] eq "MX") {
			$MX=$dnsstats[0]/$reset;
		}
		if($dnsstats[1] eq "PTR") {
			$PTR=$dnsstats[0]/$reset;
		}
		if($dnsstats[2] eq "queries") {
			$total=$total+$dnsstats[0];
		}
	}

	print "$0: DEBUG reset=$reset\n" if $ENV{'DEBUG'};
	print "$0: DEBUG A=$A\n" if $ENV{'DEBUG'};
	print "$0: DEBUG MX=$MX\n" if $ENV{'DEBUG'};
	print "$0: DEBUG PTR=$PTR\n" if $ENV{'DEBUG'};
	print "$0: DEBUG total=$total\n" if $ENV{'DEBUG'};

	$total=$total/$reset;
	
	# getting RRD
	
	$RRD="$ENV{'BBRRDS'}/$host.dnsstats.rrd";

	# if it doesn't exist, make it 
	if ( not -f $RRD ) {
			# RRAS defined in larrd.pl
			@rras = split " ",$ENV{'RRAS'};
			RRDs::create($RRD,"DS:dnstotal:GAUGE:600:0:U","DS:dnsA:GAUGE:600:0:U","DS:dnsPTR:GAUGE:600:0:U","DS:dnsMX:GAUGE:600:0:U",@rras);
                        $ERR=RRDs::error;
                        if($ERR) {
                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next;
                        }
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

        print "$0: DEBUG $RRD $ctime:$total:$A:$PTR:$MX\n" if $ENV{'DEBUG'};

	RRDs::update("$RRD","$ctime:$total:$A:$PTR:$MX");
        $ERR=RRDs::error;
        if($ERR) {
 	       print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }
  

}


##############################################
# end of script
##############################################

