#!/usr/bin/perl -w

# $Id: monlaa.cgi,v 1.2 2003/03/18 16:48:12 cncook Exp $

# monlaa.cgi:  The Monthly Load Average Average.

use strict;

# Can the perl RRD stuff for now
#use lib qw(/usr/local/rrdtool/lib/perl/);
#use RRDs;

use CGI qw/:standard *table/;
use CGI::Carp qw(fatalsToBrowser set_message);
BEGIN {
    sub handle_errors {
        my $msg = shift;
        print "$0: $msg";
    }
    set_message(\&handle_errors);
}

# Configurables

my $rrdtool = "/usr/bin/rrdtool";
my $TITLE = "Load Average Average";
my $BBRRDS = "/var/opt/bbvar/rrd";
my $nan = "&nbsp;";

my %mon= (1 =>'Jan',
	2 =>'Feb',
	3 =>'Mar',
	4 =>'Apr',
	5 =>'May',
	6 =>'Jun',
	7 =>'Jul',
	8 =>'Aug',
	9 =>'Sep',
	10=>'Oct',
	11=>'Nov',
	12=>'Dec');

chdir $BBRRDS || die "Could not change directory to $BBRRDS : $!";

my($q) = new CGI;

my $date = localtime;
my ($month, $year) = (localtime)[4,5];

$month = $month+1;
$year = $year+1900;

my $e_m = $q->param('e_m') || $month;
my $b_m = $q->param('b_m') || $e_m+1;
$b_m = "1" if $b_m eq "13";

my $e_y = $q->param('e_y') || $year;
my $b_y = $q->param('b_y') || ($b_m>$e_m ? $e_y-1 : $e_y);


# define date lists

my @monlist=();

# If the years are different we break the month list of the yearend
# we assume the begin year and end year differ by one year.
# If we want it to do more that one year add 1..12 for each year over
# one difference.

if($b_y ne $e_y) {
    @monlist = ($b_m..12,1..$e_m);
} else {
    @monlist = ($b_m..$e_m);
}

$year = $b_y;

# Build the header

my @monprint = ();

foreach (@monlist) {
    push (@monprint,$mon{$_});
}


my $host;

print header; 

print start_html($TITLE), start_table({-border=>1});

print "Begin Date: $b_m-$b_y End Date: $e_m-$e_y",br;

print Tr([ th(["host" ,@monprint ]) ]);

while (defined (my $log = <*\.la\.rrd>)) {

    $host = $log;
    $host =~ s/\.la\.rrd//;
    $host =~ s/\,/\./g;

    print Tr({align=>'CENTER'}),td(["$host"]);

    my @test;

    my $loopyear = $year;
 
    foreach my $loopmon (@monlist) {

        my $mon = $loopmon;

        # Create a next month
        my $nextmon = $mon+1;
        my $nextyear = $loopyear;

        # If we are at the years end up the year and reset the month
        $nextyear = $loopyear+1 if $nextmon eq 13;
	my $flag=$nextmon;

        $nextmon=1 if $nextmon eq 13;

        # Make the month's hold two places.
        $mon = "0$mon" if $mon < 10;
        $nextmon = "0$nextmon" if $nextmon < 10;

        @test = `$rrdtool graph nofile -s "$loopyear${mon}01 00:00" -e "$nextyear${nextmon}01 00:00-1sec" DEF:avg=$log:la:AVERAGE PRINT:avg:AVERAGE:'%5.1lf'`;

        $loopyear=$loopyear+1 if $flag eq 13;

        $test[1] =~ s/nan/$nan/i;        
        $test[1] = sprintf("%1.1f",$test[1]/100) if $test[1] !~ /$nan/;
        print td(["$test[1]"]);

# This is getting put on hold
#
#        $test = RRDs::graph("nofile","-s","$year${mon}01 00:00","-e","$nextyear${nextmon}01 00:00-1sec","DEF:avg=$log:la:AVERAGE","PRINT:avg:AVERAGE:'%5.1lf'");
#
#
#        my $ERROR = RRDs::error;
#        die "Unable to grab load average for host $host and date $year-$mon : $ERROR" if $ERROR;
#        print $test;
    }
}

print end_table, end_html;
